Subject: Refactor Extension Manager
Description

This issue collects all specs for a new EM.
It should run on PHP5.3+ so we can bundle it for 6.2 at a later stage.

Desired functionality

From the Backend

    -  Enable extension
    -  Disable extension
    -  Remove extension from disk

    -  Get extension from remote repository (also a specific version)
    -  Resolve dependencies on download
    -  Review changes (before install/update and after installation)

    -  Upload Extension ZIP via Browser

From Command Line

    -  Enable Extension
    -  Disable Extension
    -  Get extension from remote repository
    -  Resolve dependencies on install
    -  Update all extensions
    -  Fetch lists of installed extensions and available updates

General

    -  It should be possible to import data into tables that do not belong to the extension (#23965)
    -  It should be possible to sign packages (#30594)
    -  If an extension get excluded from updates, the locallang files must not be updated (#54287)
    -  Updating an extension must trigger an entry in sys_log (#19992)
    -  Should clear opcode caches in install/uninstall (#56969)
    -  Should clear classes cache "by package" if possible (#56323)
    -  Updating an extension should create a backup first (#20664, #49297)
    -  Issue an error message when offline (#43080)
    -  Updating dependencies should ask per update (#50347)

UI

    -  Get List of all extensions that offer updates (no matter if uploaded manually or installed from TER)
    -  Offer the ability to search for an extension (but exclude meta-fields like "state")
    -  Set Focus to the searchfield onload (#29628)
    -  Reload List of Extensions after updating an extension (#48867)
    -  List of Extensions should be sortable and provide indicators of the current sorting state (#55140)
    -  Filter extentions by (#43177 / #37382 / #30508 / #54997):
        -  active
        -  inactive
        -  has update available
        -  state (alpha/beta/stable)
    -  Remote Extension list should not show installed extensions
    -  UI should show dependencies and conflicts
    -  UI should allow overriding errors (dependencies/version-requirements; "I know what I'm doing"-mode)
    -  UI should allow search by author and/or category
    -  UI should show reverse dependencies (installed extensions only) (#17573)
    -  UI should show the last update from TER and when the extension has been installed (#25202)
    -  Extension updates with security issues should be moved to the top (#37199)
    -  Extensions with security updates should provide a link to the bulletin (#37156)
    -  Refactor messages in confirmation dialogs, move HTML from PHP and locallang.xlf into Fluid templates
    -  UI should paginate search results in "Get Extensions" 
    -  Offer possibility to show changelog prior to installing an extension (#43178)

Directory Layout

 |-- Packages
 |   |-- Common
 |   |   |-- my_global_ext
 |   |-- Application
 |   |   |-- tt_news
 |   |-- Framework
 |   |   |-- workspaces
 |   |-- Library
 |   |   |-- doctrine
 |   |       |-- dbal
 |   |       |-- common
 |-- Web (public Webroot)
 |-- composer.json

Subtasks:
Task # 63910: EXT:extensionmanager: Port javascript to RequireJS Resolved

History
#1 - 2014-12-23 19:40 - Mathias Schreiber
- Target version changed from 7.0 to 7.1 (Cleanup)

#2 - 2014-12-23 19:51 - Mathias Schreiber
- Target version changed from 7.1 (Cleanup) to 7.3 (Packages)

#3 - 2015-01-02 10:33 - Mathias Schreiber
- Description updated

#4 - 2015-01-02 10:33 - Mathias Schreiber
- Description updated

#5 - 2015-01-02 10:54 - Mathias Schreiber
- Description updated

#6 - 2015-01-02 10:54 - Mathias Schreiber
- Description updated

#7 - 2015-01-07 18:43 - Mathias Schreiber
- Description updated

#8 - 2015-01-08 10:33 - Mathias Schreiber
- Description updated

#9 - 2015-01-08 14:22 - Mathias Schreiber
- Description updated
#10 - 2015-01-08 14:25 - Mathias Schreiber
- Description updated

#11 - 2015-01-08 14:29 - Mathias Schreiber
- Description updated

#12 - 2015-01-08 14:40 - Mathias Schreiber
- Description updated

#13 - 2015-01-08 14:42 - Mathias Schreiber
- Description updated

#14 - 2015-01-08 14:44 - Mathias Schreiber
- Description updated

#15 - 2015-01-08 15:02 - Mathias Schreiber
- Description updated

#16 - 2015-01-08 15:03 - Mathias Schreiber
- Description updated

#17 - 2015-01-08 15:09 - Mathias Schreiber
- Description updated

#18 - 2015-01-09 05:39 - Mathias Schreiber
- Description updated

#19 - 2015-01-09 05:44 - Mathias Schreiber
- Description updated

#20 - 2015-01-09 06:02 - Mathias Schreiber
- Description updated

#21 - 2015-01-09 06:14 - Mathias Schreiber
- Description updated

#22 - 2015-01-09 06:17 - Mathias Schreiber
- Description updated

#23 - 2015-01-09 08:16 - Andreas Fernandez
- Description updated

#24 - 2015-01-09 11:54 - Mathias Schreiber
- Description updated

#25 - 2015-01-09 12:00 - Mathias Schreiber
- Description updated

#26 - 2015-01-09 12:09 - Mathias Schreiber
- Description updated

#27 - 2015-01-09 14:30 - Mathias Schreiber
- Description updated
#28 - 2015-01-09 14:31 - Mathias Schreiber
- Description updated

#29 - 2015-01-09 14:51 - Mathias Schreiber
- Description updated

#30 - 2015-01-09 14:57 - Helmut Hummel
- Description updated

#31 - 2015-01-09 14:58 - Helmut Hummel
- Description updated

#32 - 2015-01-09 15:01 - Helmut Hummel
- Description updated

#33 - 2015-01-09 17:03 - Andreas Fernandez
- Description updated

#34 - 2015-01-13 10:50 - Andreas Fernandez
- Description updated

#35 - 2015-01-13 11:04 - Stefan Neufeind
- Description updated

#36 - 2015-01-17 19:00 - Mathias Schreiber
- Description updated

#37 - 2015-01-17 20:04 - Mathias Schreiber
- Description updated

#38 - 2015-02-03 05:20 - Andreas Fernandez
- Status changed from New to Accepted

#39 - 2015-02-03 10:36 - Helmut Hummel
- Status changed from Accepted to Needs Feedback

Please, before any major work goes into that, please check back with me and or Tom Maroschik.

What exactly are the plans here? Who wants do do what?

#40 - 2015-02-03 10:37 - Helmut Hummel

It should run on PHP5.3+ so we can bundle it for 6.2 at a later stage

Ah. OK so the main target is improving the state for 6.2?

#41 - 2015-06-15 17:08 - Benjamin Mack
- Target version changed from 7.3 (Packages) to 7.4 (Backend)
#42 - 2015-06-18 11:51 - Alexander Opitz

@Helmut

I think the main target is to improve ExtensionManager generally but with the extra view on TYPO3 CMS 6.2. So it can be installed as replacement to
the ExtensionManager there.
